var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  assign: () => assign2
});
module.exports = __toCommonJS(src_exports);

// src/lib/typeMatchers/index.ts
var isMap = (input) => input instanceof Map || input && input.toString() === "[object Map]";
var isSet = (input) => input instanceof Set || input && input.toString() === "[object Set]";
var isDate = (input) => input instanceof Date || input && typeof input.toDateString === "function";

// src/lib/assignable/index.ts
var OBJECT_TYPES = ["object", "function"];
var assignable = (target) => OBJECT_TYPES.includes(typeof target) && target !== null && !isDate(target);

// src/lib/assignArray/index.ts
function assignArray(target, source) {
  if (isSet(source)) {
    source = Array.from(source);
  }
  Array.isArray(source) && source.forEach(
    (item, index) => assignable(target[index]) && assignable(item) ? assign(target[index], item) : target[index] = item === void 0 ? target[index] : item
  );
}

// src/lib/assignSet/index.ts
function assignSet(target, source) {
  if (isSet(source) || Array.isArray(source)) {
    const array = Array.from(target);
    assignArray(array, Array.from(source));
    target.clear();
    array.forEach((item) => target.add(item));
  }
}

// src/lib/assignMap/index.ts
var assignMap = (target, source) => source.forEach((key, value) => target.set(value, key));

// src/lib/clone/index.ts
function clone(instance) {
  if (Array.isArray(instance)) {
    return Array.from(instance);
  } else if (isSet(instance)) {
    return new Set(instance);
  } else if (isMap(instance)) {
    return new Map(instance);
  }
  return Object.assign({}, instance);
}

// src/lib/assignKey/index.ts
var secureKeys = [
  "__proto__",
  "constructor",
  "prototype"
];
function assignKey(target, source, key) {
  if (secureKeys.includes(key)) {
    return;
  }
  target[key] = !(key in target) || !assignable(source[key]) ? source[key] : assign(clone(target[key]), source[key]);
}

// src/lib/assignKeys/index.ts
var assignKeys = (target, source) => Object.keys(source).forEach((key) => assignKey(target, source, key));

// src/lib/assignSymbols/index.ts
var assignSymbols = (target, source) => Object.getOwnPropertySymbols(source).forEach(
  (symbol) => assignKey(target, source, symbol)
);

// src/lib/assign/index.ts
function assign(target, source) {
  if (Array.isArray(target)) {
    assignArray(target, source);
    return target;
  }
  if (isSet(target)) {
    assignSet(target, source);
    return target;
  }
  if (isMap(target) && isMap(source)) {
    assignMap(target, source);
    return target;
  }
  target = Object(target);
  source = Object(source);
  assignKeys(target, source);
  assignSymbols(target, source);
  return target;
}

// src/index.ts
function assign2(target, ...others) {
  assignable(target) && others.forEach((other) => assign(target, other));
  return target;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  assign
});
//# sourceMappingURL=index.js.map